This is a live mirror of the Perl 5 development currently hosted at https://github.com/perl/perl5
Merge CPAN version.pm tests into CORE.
[perl5.git] / lib / version / t / coretests.pm
1 #! /usr/local/perl -w
2 package main;
3 require Test::Harness;
4 *Verbose = \$Test::Harness::Verbose;
5 use Data::Dumper;
6 use File::Temp qw/tempfile/;
7 use File::Basename;
8
9 if ($Test::More::VERSION < 0.48) { # Fix for RT#48268
10     local $^W;
11     *main::use_ok = sub ($;@) {
12         my ($pkg, $req, @args) = @_;
13         eval "use $pkg $req ".join(' ',@args);
14         is ${"$pkg\::VERSION"}, $req, 'Had to manually use version';
15         # If we made it this far, we are ok.
16     };
17 }
18
19 sub BaseTests {
20
21     my ($CLASS, $method, $qv_declare) = @_;
22     my $warning;
23     local $SIG{__WARN__} = sub { $warning = $_[0] };
24
25     # Insert your test code below, the Test module is use()ed here so read
26     # its man page ( perldoc Test ) for help writing this test script.
27
28     # Test bare number processing
29     diag "tests with bare numbers" unless $ENV{PERL_CORE};
30     $version = $CLASS->$method(5.005_03);
31     is ( "$version" , "5.00503" , '5.005_03 eq 5.00503' );
32     $version = $CLASS->$method(1.23);
33     is ( "$version" , "1.23" , '1.23 eq "1.23"' );
34
35     # Test quoted number processing
36     diag "tests with quoted numbers" unless $ENV{PERL_CORE};
37     $version = $CLASS->$method("5.005_03");
38     is ( "$version" , "5.005_03" , '"5.005_03" eq "5.005_03"' );
39     $version = $CLASS->$method("v1.23");
40     is ( "$version" , "v1.23" , '"v1.23" eq "v1.23"' );
41
42     # Test stringify operator
43     diag "tests with stringify" unless $ENV{PERL_CORE};
44     $version = $CLASS->$method("5.005");
45     is ( "$version" , "5.005" , '5.005 eq "5.005"' );
46     $version = $CLASS->$method("5.006.001");
47     is ( "$version" , "5.006.001" , '5.006.001 eq v5.6.1' );
48     unlike ($warning, qr/v-string without leading 'v' deprecated/, 'No leading v');
49     $version = $CLASS->$method("v1.2.3_4");
50     is ( "$version" , "v1.2.3_4" , 'alpha version 1.2.3_4 eq v1.2.3_4' );
51
52     # test illegal formats
53     diag "test illegal formats" unless $ENV{PERL_CORE};
54     eval {my $version = $CLASS->$method("1.2_3_4")};
55     like($@, qr/multiple underscores/,
56         "Invalid version format (multiple underscores)");
57
58     eval {my $version = $CLASS->$method("1.2_3.4")};
59     like($@, qr/underscores before decimal/,
60         "Invalid version format (underscores before decimal)");
61
62     eval {my $version = $CLASS->$method("1_2")};
63     like($@, qr/alpha without decimal/,
64         "Invalid version format (alpha without decimal)");
65
66     eval { $version = $CLASS->$method("1.2b3")};
67     like($@, qr/non-numeric data/,
68         "Invalid version format (non-numeric data)");
69
70     eval { $version = $CLASS->$method("-1.23")};
71     like($@, qr/negative version number/,
72         "Invalid version format (negative version number)");
73
74     # from here on out capture the warning and test independently
75     {
76     eval{$version = $CLASS->$method("99 and 44/100 pure")};
77
78     like($@, qr/non-numeric data/,
79         "Invalid version format (non-numeric data)");
80
81     eval{$version = $CLASS->$method("something")};
82     like($@, qr/non-numeric data/,
83         "Invalid version format (non-numeric data)");
84
85     # reset the test object to something reasonable
86     $version = $CLASS->$method("1.2.3");
87
88     # Test boolean operator
89     ok ($version, 'boolean');
90
91     # Test class membership
92     isa_ok ( $version, $CLASS );
93
94     # Test comparison operators with self
95     diag "tests with self" unless $ENV{PERL_CORE};
96     is ( $version <=> $version, 0, '$version <=> $version == 0' );
97     ok ( $version == $version, '$version == $version' );
98
99     # Test Numeric Comparison operators
100     # test first with non-object
101     $version = $CLASS->$method("5.006.001");
102     $new_version = "5.8.0";
103     diag "numeric tests with non-objects" unless $ENV{PERL_CORE};
104     ok ( $version == $version, '$version == $version' );
105     ok ( $version < $new_version, '$version < $new_version' );
106     ok ( $new_version > $version, '$new_version > $version' );
107     ok ( $version != $new_version, '$version != $new_version' );
108
109     # now test with existing object
110     $new_version = $CLASS->$method($new_version);
111     diag "numeric tests with objects" unless $ENV{PERL_CORE};
112     ok ( $version < $new_version, '$version < $new_version' );
113     ok ( $new_version > $version, '$new_version > $version' );
114     ok ( $version != $new_version, '$version != $new_version' );
115
116     # now test with actual numbers
117     diag "numeric tests with numbers" unless $ENV{PERL_CORE};
118     ok ( $version->numify() == 5.006001, '$version->numify() == 5.006001' );
119     ok ( $version->numify() <= 5.006001, '$version->numify() <= 5.006001' );
120     ok ( $version->numify() < 5.008, '$version->numify() < 5.008' );
121     #ok ( $version->numify() > v5.005_02, '$version->numify() > 5.005_02' );
122
123     # test with long decimals
124     diag "Tests with extended decimal versions" unless $ENV{PERL_CORE};
125     $version = $CLASS->$method(1.002003);
126     ok ( $version == "1.2.3", '$version == "1.2.3"');
127     ok ( $version->numify == 1.002003, '$version->numify == 1.002003');
128     $version = $CLASS->$method("2002.09.30.1");
129     ok ( $version == "2002.9.30.1",'$version == 2002.9.30.1');
130     ok ( $version->numify == 2002.009030001,
131         '$version->numify == 2002.009030001');
132
133     # now test with alpha version form with string
134     $version = $CLASS->$method("1.2.3");
135     $new_version = "1.2.3_4";
136     diag "numeric tests with alpha-style non-objects" unless $ENV{PERL_CORE};
137     ok ( $version < $new_version, '$version < $new_version' );
138     ok ( $new_version > $version, '$new_version > $version' );
139     ok ( $version != $new_version, '$version != $new_version' );
140
141     $version = $CLASS->$method("1.2.4");
142     diag "numeric tests with alpha-style non-objects"
143         unless $ENV{PERL_CORE};
144     ok ( $version > $new_version, '$version > $new_version' );
145     ok ( $new_version < $version, '$new_version < $version' );
146     ok ( $version != $new_version, '$version != $new_version' );
147
148     # now test with alpha version form with object
149     $version = $CLASS->$method("1.2.3");
150     $new_version = $CLASS->$method("1.2.3_4");
151     diag "tests with alpha-style objects" unless $ENV{PERL_CORE};
152     ok ( $version < $new_version, '$version < $new_version' );
153     ok ( $new_version > $version, '$new_version > $version' );
154     ok ( $version != $new_version, '$version != $new_version' );
155     ok ( !$version->is_alpha, '!$version->is_alpha');
156     ok ( $new_version->is_alpha, '$new_version->is_alpha');
157
158     $version = $CLASS->$method("1.2.4");
159     diag "tests with alpha-style objects" unless $ENV{PERL_CORE};
160     ok ( $version > $new_version, '$version > $new_version' );
161     ok ( $new_version < $version, '$new_version < $version' );
162     ok ( $version != $new_version, '$version != $new_version' );
163
164     $version = $CLASS->$method("1.2.3.4");
165     $new_version = $CLASS->$method("1.2.3_4");
166     diag "tests with alpha-style objects with same subversion"
167         unless $ENV{PERL_CORE};
168     ok ( $version > $new_version, '$version > $new_version' );
169     ok ( $new_version < $version, '$new_version < $version' );
170     ok ( $version != $new_version, '$version != $new_version' );
171
172     diag "test implicit [in]equality" unless $ENV{PERL_CORE};
173     $version = $CLASS->$method("v1.2.3");
174     $new_version = $CLASS->$method("1.2.3.0");
175     ok ( $version == $new_version, '$version == $new_version' );
176     $new_version = $CLASS->$method("1.2.3_0");
177     ok ( $version == $new_version, '$version == $new_version' );
178     $new_version = $CLASS->$method("1.2.3.1");
179     ok ( $version < $new_version, '$version < $new_version' );
180     $new_version = $CLASS->$method("1.2.3_1");
181     ok ( $version < $new_version, '$version < $new_version' );
182     $new_version = $CLASS->$method("1.1.999");
183     ok ( $version > $new_version, '$version > $new_version' );
184
185     diag "test with version class names" unless $ENV{PERL_CORE};
186     $version = $CLASS->$method("v1.2.3");
187     eval { () = $version < 'version' };
188     like $@, qr/^Invalid version format/, "error with $version < 'version'";
189
190     # that which is not expressly permitted is forbidden
191     diag "forbidden operations" unless $ENV{PERL_CORE};
192     ok ( !eval { ++$version }, "noop ++" );
193     ok ( !eval { --$version }, "noop --" );
194     ok ( !eval { $version/1 }, "noop /" );
195     ok ( !eval { $version*3 }, "noop *" );
196     ok ( !eval { abs($version) }, "noop abs" );
197
198 SKIP: {
199     skip "version require'd instead of use'd, cannot test $qv_declare", 3
200         unless defined $qv_declare;
201     # test the $qv_declare() sub
202     diag "testing $qv_declare" unless $ENV{PERL_CORE};
203     $version = $CLASS->$qv_declare("1.2");
204     is ( "$version", "v1.2", $qv_declare.'("1.2") == "1.2.0"' );
205     $version = $CLASS->$qv_declare(1.2);
206     is ( "$version", "v1.2", $qv_declare.'(1.2) == "1.2.0"' );
207     isa_ok( $CLASS->$qv_declare('5.008'), $CLASS );
208 }
209
210     # test creation from existing version object
211     diag "create new from existing version" unless $ENV{PERL_CORE};
212     ok (eval {$new_version = $CLASS->$method($version)},
213             "new from existing object");
214     ok ($new_version == $version, "class->$method($version) identical");
215     $new_version = $version->$method(0);
216     isa_ok ($new_version, $CLASS );
217     is ($new_version, "0", "version->$method() doesn't clone");
218     $new_version = $version->$method("1.2.3");
219     is ($new_version, "1.2.3" , '$version->$method("1.2.3") works too');
220
221     # test the CVS revision mode
222     diag "testing CVS Revision" unless $ENV{PERL_CORE};
223     $version = new $CLASS qw$Revision: 1.2$;
224     ok ( $version == "1.2.0", 'qw$Revision: 1.2$ == 1.2.0' );
225     $version = new $CLASS qw$Revision: 1.2.3.4$;
226     ok ( $version == "1.2.3.4", 'qw$Revision: 1.2.3.4$ == 1.2.3.4' );
227
228     # test the CPAN style reduced significant digit form
229     diag "testing CPAN-style versions" unless $ENV{PERL_CORE};
230     $version = $CLASS->$method("1.23_01");
231     is ( "$version" , "1.23_01", "CPAN-style alpha version" );
232     ok ( $version > 1.23, "1.23_01 > 1.23");
233     ok ( $version < 1.24, "1.23_01 < 1.24");
234
235     # test reformed UNIVERSAL::VERSION
236     diag "Replacement UNIVERSAL::VERSION tests" unless $ENV{PERL_CORE};
237
238     my $error_regex = $] < 5.006
239         ? 'version \d required'
240         : 'does not define \$t.{7}::VERSION';
241
242     {
243         my ($fh, $filename) = tempfile('tXXXXXXX', SUFFIX => '.pm', UNLINK => 1);
244         (my $package = basename($filename)) =~ s/\.pm$//;
245         print $fh "package $package;\n\$$package\::VERSION=0.58;\n1;\n";
246         close $fh;
247
248         $version = 0.58;
249         eval "use lib '.'; use $package $version";
250         unlike($@, qr/$package version $version/,
251                 'Replacement eval works with exact version');
252
253         # test as class method
254         $new_version = $package->VERSION;
255         cmp_ok($new_version,'==',$version, "Called as class method");
256
257         eval "print Completely::Unknown::Module->VERSION";
258         if ( $] < 5.008 ) {
259             unlike($@, qr/$error_regex/,
260                 "Don't freak if the module doesn't even exist");
261         }
262         else {
263             unlike($@, qr/defines neither package nor VERSION/,
264                 "Don't freak if the module doesn't even exist");
265         }
266
267         # this should fail even with old UNIVERSAL::VERSION
268         $version += 0.01;
269         eval "use lib '.'; use $package $version";
270         like($@, qr/$package version $version/,
271                 'Replacement eval works with incremented version');
272
273         $version =~ s/0+$//; #convert to string and remove trailing 0's
274         chop($version); # shorten by 1 digit, should still succeed
275         eval "use lib '.'; use $package $version";
276         unlike($@, qr/$package version $version/,
277                 'Replacement eval works with single digit');
278
279         # this would fail with old UNIVERSAL::VERSION
280         $version += 0.1;
281         eval "use lib '.'; use $package $version";
282         like($@, qr/$package version $version/,
283                 'Replacement eval works with incremented digit');
284         unlink $filename;
285     }
286
287     { # dummy up some variously broken modules for testing
288         my ($fh, $filename) = tempfile('tXXXXXXX', SUFFIX => '.pm', UNLINK => 1);
289         (my $package = basename($filename)) =~ s/\.pm$//;
290         print $fh "1;\n";
291         close $fh;
292
293         eval "use lib '.'; use $package 3;";
294         if ( $] < 5.008 ) {
295             like($@, qr/$error_regex/,
296                 'Replacement handles modules without package or VERSION');
297         }
298         else {
299             like($@, qr/defines neither package nor VERSION/,
300                 'Replacement handles modules without package or VERSION');
301         }
302         eval "use lib '.'; use $package; \$version = $package->VERSION";
303         unlike ($@, qr/$error_regex/,
304             'Replacement handles modules without package or VERSION');
305         ok (!defined($version), "Called as class method");
306         unlink $filename;
307     }
308
309     { # dummy up some variously broken modules for testing
310         my ($fh, $filename) = tempfile('tXXXXXXX', SUFFIX => '.pm', UNLINK => 1);
311         (my $package = basename($filename)) =~ s/\.pm$//;
312         print $fh "package $package;\n#look ma no VERSION\n1;\n";
313         close $fh;
314         eval "use lib '.'; use $package 3;";
315         like ($@, qr/$error_regex/,
316             'Replacement handles modules without VERSION');
317         eval "use lib '.'; use $package; print $package->VERSION";
318         unlike ($@, qr/$error_regex/,
319             'Replacement handles modules without VERSION');
320         unlink $filename;
321     }
322
323     { # dummy up some variously broken modules for testing
324         my ($fh, $filename) = tempfile('tXXXXXXX', SUFFIX => '.pm', UNLINK => 1);
325         (my $package = basename($filename)) =~ s/\.pm$//;
326         print $fh "package $package;\n\@VERSION = ();\n1;\n";
327         close $fh;
328         eval "use lib '.'; use $package 3;";
329         like ($@, qr/$error_regex/,
330             'Replacement handles modules without VERSION');
331         eval "use lib '.'; use $package; print $package->VERSION";
332         unlike ($@, qr/$error_regex/,
333             'Replacement handles modules without VERSION');
334         unlink $filename;
335     }
336 SKIP:    { # https://rt.perl.org/rt3/Ticket/Display.html?id=95544
337         skip "version require'd instead of use'd, cannot test UNIVERSAL::VERSION", 2
338             unless defined $qv_declare;
339         my ($fh, $filename) = tempfile('tXXXXXXX', SUFFIX => '.pm', UNLINK => 1);
340         (my $package = basename($filename)) =~ s/\.pm$//;
341         print $fh "package $package;\n\$VERSION = '3alpha';\n1;\n";
342         close $fh;
343         eval "use lib '.'; use $package; print $package->VERSION";
344         like ($@, qr/Invalid version format \(non-numeric data\)/,
345             'Warn about bad \$VERSION');
346         eval "use lib '.'; use $package 1;";
347         like ($@, qr/Invalid version format \(non-numeric data\)/,
348             'Warn about bad $VERSION');
349     }
350
351 SKIP:   {
352         skip 'Cannot test bare v-strings with Perl < 5.6.0', 4
353                 if $] < 5.006_000;
354         diag "Tests with v-strings" unless $ENV{PERL_CORE};
355         $version = $CLASS->$method(1.2.3);
356         ok("$version" eq "v1.2.3", '"$version" eq 1.2.3');
357         $version = $CLASS->$method(1.0.0);
358         $new_version = $CLASS->$method(1);
359         ok($version == $new_version, '$version == $new_version');
360         skip "version require'd instead of use'd, cannot test declare", 1
361             unless defined $qv_declare;
362         $version = &$qv_declare(1.2.3);
363         ok("$version" eq "v1.2.3", 'v-string initialized $qv_declare()');
364     }
365
366 SKIP:   {
367         skip 'Cannot test bare alpha v-strings with Perl < 5.8.1', 2
368                 if $] lt 5.008_001;
369         diag "Tests with bare alpha v-strings" unless $ENV{PERL_CORE};
370         $version = $CLASS->$method(v1.2.3_4);
371         is($version, "v1.2.3_4", '"$version" eq "v1.2.3_4"');
372         $version = $CLASS->$method(eval "v1.2.3_4");
373         is($version, "v1.2.3_4", '"$version" eq "v1.2.3_4" (from eval)');
374     }
375
376     diag "Tests with real-world (malformed) data" unless $ENV{PERL_CORE};
377
378     # trailing zero testing (reported by Andreas Koenig).
379     $version = $CLASS->$method("1");
380     ok($version->numify eq "1.000", "trailing zeros preserved");
381     $version = $CLASS->$method("1.0");
382     ok($version->numify eq "1.000", "trailing zeros preserved");
383     $version = $CLASS->$method("1.0.0");
384     ok($version->numify eq "1.000000", "trailing zeros preserved");
385     $version = $CLASS->$method("1.0.0.0");
386     ok($version->numify eq "1.000000000", "trailing zeros preserved");
387
388     # leading zero testing (reported by Andreas Koenig).
389     $version = $CLASS->$method(".7");
390     ok($version->numify eq "0.700", "leading zero inferred");
391
392     # leading space testing (reported by Andreas Koenig).
393     $version = $CLASS->$method(" 1.7");
394     ok($version->numify eq "1.700", "leading space ignored");
395
396     # RT 19517 - deal with undef and 'undef' initialization
397     ok("$version" ne 'undef', "Undef version comparison #1");
398     ok("$version" ne undef, "Undef version comparison #2");
399     $version = $CLASS->$method('undef');
400     unlike($warning, qr/^Version string 'undef' contains invalid data/,
401         "Version string 'undef'");
402
403     $version = $CLASS->$method(undef);
404     like($warning, qr/^Use of uninitialized value/,
405         "Version string 'undef'");
406     ok($version == 'undef', "Undef version comparison #3");
407     ok($version ==  undef,  "Undef version comparison #4");
408     eval "\$version = \$CLASS->$method()"; # no parameter at all
409     unlike($@, qr/^Bizarre copy of CODE/, "No initializer at all");
410     ok($version == 'undef', "Undef version comparison #5");
411     ok($version ==  undef,  "Undef version comparison #6");
412
413     $version = $CLASS->$method(0.000001);
414     unlike($warning, qr/^Version string '1e-06' contains invalid data/,
415         "Very small version objects");
416     }
417
418 SKIP: {
419         my $warning;
420         local $SIG{__WARN__} = sub { $warning = $_[0] };
421         # dummy up a legal module for testing RT#19017
422         my ($fh, $filename) = tempfile('tXXXXXXX', SUFFIX => '.pm', UNLINK => 1);
423         (my $package = basename($filename)) =~ s/\.pm$//;
424         print $fh <<"EOF";
425 package $package;
426 use $CLASS; \$VERSION = ${CLASS}->new('0.0.4');
427 1;
428 EOF
429         close $fh;
430
431         eval "use lib '.'; use $package 0.000008;";
432         like ($@, qr/^$package version 0.000008 required/,
433             "Make sure very small versions don't freak");
434         eval "use lib '.'; use $package 1;";
435         like ($@, qr/^$package version 1 required/,
436             "Comparing vs. version with no decimal");
437         eval "use lib '.'; use $package 1.;";
438         like ($@, qr/^$package version 1 required/,
439             "Comparing vs. version with decimal only");
440         if ( $] < 5.006_000 ) {
441             skip 'Cannot "use" extended versions with Perl < 5.6.0', 3;
442         }
443         eval "use lib '.'; use $package v0.0.8;";
444         my $regex = "^$package version v0.0.8 required";
445         like ($@, qr/$regex/, "Make sure very small versions don't freak");
446
447         $regex =~ s/8/4/; # set for second test
448         eval "use lib '.'; use $package v0.0.4;";
449         unlike($@, qr/$regex/, 'Succeed - required == VERSION');
450         cmp_ok ( $package->VERSION, 'eq', '0.0.4', 'No undef warnings' );
451         unlink $filename;
452     }
453
454 SKIP: {
455     skip 'Cannot test "use base qw(version)"  when require is used', 3
456         unless defined $qv_declare;
457     my ($fh, $filename) = tempfile('tXXXXXXX', SUFFIX => '.pm', UNLINK => 1);
458     (my $package = basename($filename)) =~ s/\.pm$//;
459     print $fh <<"EOF";
460 package $package;
461 use base qw(version);
462 1;
463 EOF
464     close $fh;
465     # need to eliminate any other $qv_declare()'s
466     undef *{"main\::$qv_declare"};
467     ok(!defined(&{"main\::$qv_declare"}), "make sure we cleared $qv_declare() properly");
468     eval "use lib '.'; use $package qw/declare qv/;";
469     ok(defined(&{"main\::$qv_declare"}), "make sure we exported $qv_declare() properly");
470     isa_ok( &$qv_declare(1.2), $package);
471     unlink $filename;
472 }
473
474 SKIP: {
475         if ( $] < 5.006_000 ) {
476             skip 'Cannot "use" extended versions with Perl < 5.6.0', 3;
477         }
478         my ($fh, $filename) = tempfile('tXXXXXXX', SUFFIX => '.pm', UNLINK => 1);
479         (my $package = basename($filename)) =~ s/\.pm$//;
480         print $fh <<"EOF";
481 package $package;
482 \$VERSION = 1.0;
483 1;
484 EOF
485         close $fh;
486         eval "use lib '.'; use $package 1.001;";
487         like ($@, qr/^$package version 1.001 required/,
488             "User typed numeric so we error with numeric");
489         eval "use lib '.'; use $package v1.1.0;";
490         like ($@, qr/^$package version v1.1.0 required/,
491             "User typed extended so we error with extended");
492         unlink $filename;
493     }
494
495     eval 'my $v = $CLASS->$method("1._1");';
496     unlike($@, qr/^Invalid version format \(alpha with zero width\)/,
497         "Invalid version format 1._1");
498
499     {
500         my $warning;
501         local $SIG{__WARN__} = sub { $warning = $_[0] };
502         eval 'my $v = $CLASS->$method(~0);';
503         unlike($@, qr/Integer overflow in version/, "Too large version");
504         like($warning, qr/Integer overflow in version/, "Too large version");
505     }
506
507     {
508         # http://rt.cpan.org/Public/Bug/Display.html?id=30004
509         my $v1 = $CLASS->$method("v0.1_1");
510         (my $alpha1 = Dumper($v1)) =~ s/.+'alpha' => ([^,]+),.+/$1/ms;
511         my $v2 = $CLASS->$method($v1);
512         (my $alpha2 = Dumper($v2)) =~ s/.+'alpha' => ([^,]+),.+/$1/ms;
513         is $alpha2, $alpha1, "Don't fall for Data::Dumper's tricks";
514     }
515
516     {
517         # http://rt.perl.org/rt3/Ticket/Display.html?id=56606
518         my $badv = bless { version => [1,2,3] }, "version";
519         is $badv, '1.002003', "Deal with badly serialized versions from YAML";
520         my $badv2 = bless { qv => 1, version => [1,2,3] }, "version";
521         is $badv2, 'v1.2.3', "Deal with badly serialized versions from YAML ";
522     }
523
524     {
525         # https://rt.cpan.org/Public/Bug/Display.html?id=70950
526         # test indirect usage of version objects
527         my $sum = 0;
528         eval '$sum += $CLASS->$method("v2.0.0")';
529         like $@, qr/operation not supported with version object/,
530             'No math operations with version objects';
531         # test direct usage of version objects
532         my $v = $CLASS->$method("v2.0.0");
533         eval '$v += 1';
534         like $@, qr/operation not supported with version object/,
535             'No math operations with version objects';
536     }
537
538     {
539         # https://rt.cpan.org/Ticket/Display.html?id=72365
540         # https://rt.perl.org/rt3/Ticket/Display.html?id=102586
541         eval 'my $v = $CLASS->$method("version")';
542         like $@, qr/Invalid version format/,
543             'The string "version" is not a version';
544         eval 'my $v = $CLASS->$method("ver510n")';
545         like $@, qr/Invalid version format/,
546             'All strings starting with "v" are not versions';
547     }
548
549 SKIP: {
550         if ( $] < 5.006_000 ) {
551             skip 'No v-string support at all < 5.6.0', 2;
552         }
553         # https://rt.cpan.org/Ticket/Display.html?id=49348
554         my $v = $CLASS->$method("420");
555         is "$v", "420", 'Correctly guesses this is not a v-string';
556         $v = $CLASS->$method(4.2.0);
557         is "$v", 'v4.2.0', 'Correctly guess that this is a v-string';
558     }
559 SKIP: {
560         if ( $] < 5.006_000 ) {
561             skip 'No v-string support at all < 5.6.0', 4;
562         }
563         # https://rt.cpan.org/Ticket/Display.html?id=50347
564         # Check that the qv() implementation does not change
565
566         ok $CLASS->$method(1.2.3) < $CLASS->$method(1.2.3.1), 'Compare 3 and 4 digit v-strings' ;
567         ok $CLASS->$method(v1.2.3) < $CLASS->$method(v1.2.3.1), 'Compare 3 and 4 digit v-strings, leaving v';
568         ok $CLASS->$method("1.2.3") < $CLASS->$method("1.2.3.1"), 'Compare 3 and 4 digit v-strings, quoted';
569         ok $CLASS->$method("v1.2.3") < $CLASS->$method("v1.2.3.1"), 'Compare 3 and 4 digit v-strings, quoted leading v';
570     }
571
572     {
573         eval '$CLASS->$method("version")';
574         pass("no crash with ${CLASS}->${method}('version')");
575         {
576             package _102586;
577             sub TIESCALAR { bless [] }
578             sub FETCH { "version" }
579             sub STORE { }
580             my $v;
581             tie $v, __PACKAGE__;
582             $v = $CLASS->$method(1);
583             eval '$CLASS->$method($v)';
584         }
585         pass('no crash with version->new($tied) where $tied returns "version"');
586     }
587 }
588
589 1;